/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// SarefDevice A tangible object designed to accomplish a particular task in households, common public buildings or offices. In order to accomplish this task, the device performs one or more functions. For example, a washing machine is designed to wash (task) and to accomplish this task it performs a start and stop function. Devices can be structured in categories (subclasses) that reflect the different domain in which a device is used, e.g., smart appliances domain (subclass FunctionRelated) vs. building domain (subclass BuildingRelated) vs. smart grid domain (subclass EnergyRelated). New categories can be defined,if needed, to reflect other differences, for example different points of view, such as the point of view of the device's user vs. the point of view of the device's manufacturer. We propose a list of devices that are relevant for the purpose of SAREF, but this list can be extended.
type SarefDevice interface {
	owl.Thing
	sarefConsistsOfMultipleSarefDevice
	sarefControlsPropertyMultipleSarefProperty
	sarefHasProfileMultipleSarefProfile
	sarefHasStateMultipleSarefState
	sarefHasTypicalConsumptionMultipleSarefProperty
	sarefIsUsedForMultipleSarefCommodity
	sarefMakesMeasurementMultipleSarefMeasurement
	sarefMeasuresPropertyMultipleSarefProperty
	sarefOffersMultipleSarefService
	sarefAccomplishesMultipleSarefTask
	sarefHasFunctionMultipleSarefFunction
	sarefHasDescriptionSinglestring
	sarefHasManufacturerSinglestring
	sarefHasModelSinglestring
	IsSarefDevice() bool // indicates base class
}

// sSarefDevice A tangible object designed to accomplish a particular task in households, common public buildings or offices. In order to accomplish this task, the device performs one or more functions. For example, a washing machine is designed to wash (task) and to accomplish this task it performs a start and stop function. Devices can be structured in categories (subclasses) that reflect the different domain in which a device is used, e.g., smart appliances domain (subclass FunctionRelated) vs. building domain (subclass BuildingRelated) vs. smart grid domain (subclass EnergyRelated). New categories can be defined,if needed, to reflect other differences, for example different points of view, such as the point of view of the device's user vs. the point of view of the device's manufacturer. We propose a list of devices that are relevant for the purpose of SAREF, but this list can be extended.
type sSarefDevice struct {
	propCommon
	propSarefConsistsOfBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice
	propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty
	propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile
	propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState
	propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower
	propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity
	propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement
	propSarefMeasuresPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty
	propSarefOffersBaseSarefServiceTypeSarefServiceMultipleSarefService
	propSarefAccomplishesBaseSarefTaskTypeSarefTaskMultipleSarefTask
	propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction
	propSarefHasDescriptionBasestringTypestringSinglestring
	propSarefHasManufacturerBasestringTypestringSinglestring
	propSarefHasModelBasestringTypestringSinglestring
}

// NewSarefDevice creates a new SarefDevice
func (mod *Model) NewSarefDevice(iri string) (ret SarefDevice, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sSarefDevice{}
	pc := propCommon{iri: iri, typ: "SarefDevice", model: mod}
	res.propCommon = pc
	mod.addSarefDevice(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sSarefDevice) makeMaps() {
	res.sarefConsistsOf = make(map[string]SarefDevice)
	res.sarefControlsProperty = make(map[string]SarefProperty)
	res.sarefHasProfile = make(map[string]SarefProfile)
	res.sarefHasState = make(map[string]SarefState)
	res.sarefHasTypicalConsumption = make(map[string]SarefProperty)
	res.sarefIsUsedFor = make(map[string]SarefCommodity)
	res.sarefMakesMeasurement = make(map[string]SarefMeasurement)
	res.sarefMeasuresProperty = make(map[string]SarefProperty)
	res.sarefOffers = make(map[string]SarefService)
	res.sarefAccomplishes = make(map[string]SarefTask)
	res.sarefHasFunction = make(map[string]SarefFunction)
	return
}

// addSarefDevice adds SarefDevice to model
func (mod *Model) addSarefDevice(res SarefDevice) {
	mod.mSarefDevice[res.IRI()] = res
	mod.mThing[res.IRI()] = res
	return
}

// SarefDevice returns all resources with given prefix
func (mod *Model) SarefDevice(prefix string) (res []SarefDevice) {
	for i := range mod.mSarefDevice {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mSarefDevice[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sSarefDevice) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "https://w3id.org/saref#consistsOf":
		res.propSarefConsistsOfBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice.removeObject(obj)
	case "https://w3id.org/saref#controlsProperty":
		res.propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.removeObject(obj)
	case "https://w3id.org/saref#hasProfile":
		res.propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile.removeObject(obj)
	case "https://w3id.org/saref#hasState":
		res.propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState.removeObject(obj)
	case "https://w3id.org/saref#hasTypicalConsumption":
		res.propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower.removeObject(obj)
	case "https://w3id.org/saref#isUsedFor":
		res.propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity.removeObject(obj)
	case "https://w3id.org/saref#makesMeasurement":
		res.propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.removeObject(obj)
	case "https://w3id.org/saref#measuresProperty":
		res.propSarefMeasuresPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.removeObject(obj)
	case "https://w3id.org/saref#offers":
		if v, ok := obj.(SarefService); ok {
			res.DelSarefOffers(v)
		}
	case "https://w3id.org/saref#accomplishes":
		if v, ok := obj.(SarefTask); ok {
			res.DelSarefAccomplishes(v)
		}
	case "https://w3id.org/saref#hasFunction":
		res.propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction.removeObject(obj)
	default:
	}
	return
}

// isSarefDevice indicates base class
func (res *sSarefDevice) IsSarefDevice() bool {
	return true
}

// SetSarefOffers is setter of A relationship between a device and a service
func (res *sSarefDevice) SetSarefOffers(in []SarefService) (err error) {
	temp := res.sarefOffers
	res.sarefOffers = make(map[string]SarefService)
	for i := range temp {
		temp[i].DelSarefIsOfferedBy(res)
	}
	err = res.AddSarefOffers(in...)
	return
}

// AddSarefOffers adds A relationship between a device and a service
func (res *sSarefDevice) AddSarefOffers(in ...SarefService) (err error) {
	for i := range in {
		if _, ok := res.sarefOffers[in[i].IRI()]; !ok {
			res.sarefOffers[in[i].IRI()] = in[i]
			in[i].AddSarefIsOfferedBy(res)
		}
	}
	return
}

// DelSarefOffers deletes A relationship between a device and a service
func (res *sSarefDevice) DelSarefOffers(in ...SarefService) (err error) {
	for i := range in {
		if _, ok := res.sarefOffers[in[i].IRI()]; ok {
			delete(res.sarefOffers, in[i].IRI())
			in[i].DelSarefIsOfferedBy(res)
		}
	}
	return
}

// SetSarefAccomplishes is setter of A relationship between a certain entity (e.g., a device) and the task it accomplishes
func (res *sSarefDevice) SetSarefAccomplishes(in []SarefTask) (err error) {
	temp := res.sarefAccomplishes
	res.sarefAccomplishes = make(map[string]SarefTask)
	for i := range temp {
		temp[i].DelSarefIsAccomplishedBy(res)
	}
	err = res.AddSarefAccomplishes(in...)
	return
}

// AddSarefAccomplishes adds A relationship between a certain entity (e.g., a device) and the task it accomplishes
func (res *sSarefDevice) AddSarefAccomplishes(in ...SarefTask) (err error) {
	for i := range in {
		if _, ok := res.sarefAccomplishes[in[i].IRI()]; !ok {
			res.sarefAccomplishes[in[i].IRI()] = in[i]
			in[i].AddSarefIsAccomplishedBy(res)
		}
	}
	return
}

// DelSarefAccomplishes deletes A relationship between a certain entity (e.g., a device) and the task it accomplishes
func (res *sSarefDevice) DelSarefAccomplishes(in ...SarefTask) (err error) {
	for i := range in {
		if _, ok := res.sarefAccomplishes[in[i].IRI()]; ok {
			delete(res.sarefAccomplishes, in[i].IRI())
			in[i].DelSarefIsAccomplishedBy(res)
		}
	}
	return
}

// InitFromNode initializes the resource from a graph node
func (res *sSarefDevice) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sSarefDevice) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "https://w3id.org/saref#consistsOf":
		res.propSarefConsistsOfBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#controlsProperty":
		res.propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasProfile":
		res.propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasState":
		res.propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasTypicalConsumption":
		res.propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#isUsedFor":
		res.propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#makesMeasurement":
		res.propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#measuresProperty":
		res.propSarefMeasuresPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#offers":
		if obj, ok := res.model.mSarefService[pred.Object.Term.String()]; ok {
			res.AddSarefOffers(obj)
		}
	case "https://w3id.org/saref#accomplishes":
		if obj, ok := res.model.mSarefTask[pred.Object.Term.String()]; ok {
			res.AddSarefAccomplishes(obj)
		}
	case "https://w3id.org/saref#hasFunction":
		res.propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasDescription":
		res.propSarefHasDescriptionBasestringTypestringSinglestring.init(pred.Object.Term.String())
	case "https://w3id.org/saref#hasManufacturer":
		res.propSarefHasManufacturerBasestringTypestringSinglestring.init(pred.Object.Term.String())
	case "https://w3id.org/saref#hasModel":
		res.propSarefHasModelBasestringTypestringSinglestring.init(pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sSarefDevice) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "https://w3id.org/saref#Device", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sSarefDevice) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propSarefConsistsOfBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice.toGraph(node, g)
	res.propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.toGraph(node, g)
	res.propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile.toGraph(node, g)
	res.propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState.toGraph(node, g)
	res.propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower.toGraph(node, g)
	res.propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity.toGraph(node, g)
	res.propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.toGraph(node, g)
	res.propSarefMeasuresPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.toGraph(node, g)
	res.propSarefOffersBaseSarefServiceTypeSarefServiceMultipleSarefService.toGraph(node, g)
	res.propSarefAccomplishesBaseSarefTaskTypeSarefTaskMultipleSarefTask.toGraph(node, g)
	res.propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction.toGraph(node, g)
	res.propSarefHasDescriptionBasestringTypestringSinglestring.toGraph(node, g)
	res.propSarefHasManufacturerBasestringTypestringSinglestring.toGraph(node, g)
	res.propSarefHasModelBasestringTypestringSinglestring.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sSarefDevice) String() (ret string) {
	ret = res.iri + " " + "SarefDevice\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sSarefDevice) propsString() (ret string) {
	ret = ""
	ret += res.propSarefConsistsOfBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice.String()
	ret += res.propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.String()
	ret += res.propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile.String()
	ret += res.propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState.String()
	ret += res.propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower.String()
	ret += res.propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity.String()
	ret += res.propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement.String()
	ret += res.propSarefMeasuresPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.String()
	ret += res.propSarefOffersBaseSarefServiceTypeSarefServiceMultipleSarefService.String()
	ret += res.propSarefAccomplishesBaseSarefTaskTypeSarefTaskMultipleSarefTask.String()
	ret += res.propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction.String()
	ret += res.propSarefHasDescriptionBasestringTypestringSinglestring.String()
	ret += res.propSarefHasManufacturerBasestringTypestringSinglestring.String()
	ret += res.propSarefHasModelBasestringTypestringSinglestring.String()
	return
}


